//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4B4CDAA7003F.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4B4CDAA7003F.cm

//## begin module%4B4CDAA7003F.cp preserve=no
//## end module%4B4CDAA7003F.cp

//## Module: CreateContourPlotGroups%4B4CDAA7003F; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/CreateContourPlotGroups.h

#ifndef CREATECONTOURPLOTGROUPS_H
#define CREATECONTOURPLOTGROUPS_H 1

//## begin module%4B4CDAA7003F.additionalIncludes preserve=no
//## end module%4B4CDAA7003F.additionalIncludes

//## begin module%4B4CDAA7003F.includes preserve=yes
#include <xsTypes.h>
#include <XSFit/Fit/Grid.h>
#include <XSPlot/Plot/PlotGroup.h>
#include <XSPlot/Plot/PlotSettings.h>
#include <XSPlot/Plot/PlotStyle.h>
#include <XSPlot/Plot/PlotTypes.h>
#include <XSUtil/Error/Error.h>
#include <memory>
//## end module%4B4CDAA7003F.includes

// PlotGroupCreator
#include <XSPlot/Plot/PlotGroupCreator.h>
//## begin module%4B4CDAA7003F.declarations preserve=no
//## end module%4B4CDAA7003F.declarations

//## begin module%4B4CDAA7003F.additionalDeclarations preserve=yes
class Step;
class MarginGrid;

template<typename T>
class ContourPolicy;

template<>
class ContourPolicy<Step>
{
   public:
      static Grid* getGrid();
      static void validate(const Grid* grid);
      static Real getMinVal(const Grid* grid);
      static void getInitLevels(const Grid* grid, RealArray& levels);
      static string getParLabel(size_t idx, const Grid* grid);
      static string getYLabel(const PlotSettings& settings);
      static string getTitle(const PlotSettings& settings, size_t nDim);
};

template<>
class ContourPolicy<MarginGrid>
{
   public:
      static Grid* getGrid();
      static void validate(const Grid* grid);
      static Real getMinVal(const Grid* grid);
      static void getInitLevels(const Grid* grid, RealArray& levels);
      static string getParLabel(size_t idx, const Grid* grid);
      static string getYLabel(const PlotSettings& settings);
      static string getTitle(const PlotSettings& settings, size_t nDim);
};

template<typename T>
struct ContourTraits;

template<>
struct ContourTraits<Step>
{
   static const string cmdName;
   static const bool addCrosshair;
};

template<>
struct ContourTraits<MarginGrid>
{
   static const string cmdName;
   static const bool addCrosshair;
};
//## end module%4B4CDAA7003F.additionalDeclarations


//## begin CreateContourPlotGroups%4B4CDB6502B9.preface preserve=yes
//## end CreateContourPlotGroups%4B4CDB6502B9.preface

//## Class: CreateContourPlotGroups%4B4CDB6502B9; Parameterized Class
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



template <typename T>
class CreateContourPlotGroups : public PlotGroupCreator  //## Inherits: <unnamed>%4B4CDBAE02A1
{
  //## begin CreateContourPlotGroups%4B4CDB6502B9.initialDeclarations preserve=yes
  //## end CreateContourPlotGroups%4B4CDB6502B9.initialDeclarations

  public:
    //## Constructors (generated)
      CreateContourPlotGroups();

    //## Destructor (generated)
      virtual ~CreateContourPlotGroups();


    //## Other Operations (specified)
      //## Operation: createPlotGroups%4B4CDDBD00AC
      virtual std::vector<PlotGroup*> createPlotGroups (const PlotSettings& settings);

    // Additional Public Declarations
      //## begin CreateContourPlotGroups%4B4CDB6502B9.public preserve=yes
      //## end CreateContourPlotGroups%4B4CDB6502B9.public

  protected:
    // Additional Protected Declarations
      //## begin CreateContourPlotGroups%4B4CDB6502B9.protected preserve=yes
      //## end CreateContourPlotGroups%4B4CDB6502B9.protected

  private:
    //## Constructors (generated)
      CreateContourPlotGroups(const CreateContourPlotGroups< T > &right);

    //## Assignment Operation (generated)
      CreateContourPlotGroups< T > & operator=(const CreateContourPlotGroups< T > &right);

    // Additional Private Declarations
      //## begin CreateContourPlotGroups%4B4CDB6502B9.private preserve=yes
      //## end CreateContourPlotGroups%4B4CDB6502B9.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin CreateContourPlotGroups%4B4CDB6502B9.implementation preserve=yes
      //## end CreateContourPlotGroups%4B4CDB6502B9.implementation

};

//## begin CreateContourPlotGroups%4B4CDB6502B9.postscript preserve=yes
//## end CreateContourPlotGroups%4B4CDB6502B9.postscript

// Parameterized Class CreateContourPlotGroups 

// Parameterized Class CreateContourPlotGroups 

template <typename T>
CreateContourPlotGroups<T>::CreateContourPlotGroups()
  //## begin CreateContourPlotGroups::CreateContourPlotGroups%4B4CDB6502B9_const.hasinit preserve=no
  //## end CreateContourPlotGroups::CreateContourPlotGroups%4B4CDB6502B9_const.hasinit
  //## begin CreateContourPlotGroups::CreateContourPlotGroups%4B4CDB6502B9_const.initialization preserve=yes
  : PlotGroupCreator()
  //## end CreateContourPlotGroups::CreateContourPlotGroups%4B4CDB6502B9_const.initialization
{
  //## begin CreateContourPlotGroups::CreateContourPlotGroups%4B4CDB6502B9_const.body preserve=yes
  //## end CreateContourPlotGroups::CreateContourPlotGroups%4B4CDB6502B9_const.body
}


template <typename T>
CreateContourPlotGroups<T>::~CreateContourPlotGroups()
{
  //## begin CreateContourPlotGroups::~CreateContourPlotGroups%4B4CDB6502B9_dest.body preserve=yes
  //## end CreateContourPlotGroups::~CreateContourPlotGroups%4B4CDB6502B9_dest.body
}



//## Other Operations (implementation)
template <typename T>
std::vector<PlotGroup*> CreateContourPlotGroups<T>::createPlotGroups (const PlotSettings& settings)
{
  //## begin CreateContourPlotGroups::createPlotGroups%4B4CDDBD00AC.body preserve=yes
   // ASSUME that ContourPlot has already verified the existence of the relevant
   // Grid during its processAdditionalArguments phase, and it should have
   // checked that it is 1 or 2D.
   
   std::vector<PlotGroup*> plotGroups;   
   const Grid* grid = ContourPolicy<T>::getGrid();
   const size_t nDim = grid->getParameter().size();
   if (nDim == 1)
   {
      const Grid::ParameterSpec* ps = grid->getParameter()[0];
      // Though this is a contour plot, for 1-D case it uses
      // the regular PlotGroup constructor.
      std::auto_ptr<PlotGroup> apGr(new PlotGroup(ps->parameterValues.size(),0,true));
      const size_t nPts = apGr->n;
      const RealArray& gridData = grid->getGrid();
      std::vector<Real>& yVals = apGr->yData.data;
      apGr->xAxis.data = ps->parameterValues;
      for (size_t i=0; i<nPts; ++i)
         yVals[i] = gridData[i];
      apGr->xAxis.errors.clear();
      apGr->yData.errors.clear();
      plotGroups.push_back(apGr.release());
   }
   else if (nDim == 2)
   {   
      const Grid::ParameterSpec* xps = grid->getParameter()[0];
      const Grid::ParameterSpec* yps = grid->getParameter()[1];
      std::auto_ptr<PlotGroup> apGr(new PlotGroup(xps->parameterValues,
                           yps->parameterValues));

      std::vector<Real>& pgData = apGr->model[0].data;
      const RealArray& gridData = grid->getGrid();
      const size_t nPts = gridData.size();
      if (nPts != apGr->n)
         throw RedAlert("Grid size mismatch in createPlotGroups function.");
      for (size_t i=0; i<nPts; ++i)
         pgData[i] = gridData[i];

      plotGroups.push_back(apGr.release());
   }
   return plotGroups;
  //## end CreateContourPlotGroups::createPlotGroups%4B4CDDBD00AC.body
}

// Additional Declarations
  //## begin CreateContourPlotGroups%4B4CDB6502B9.declarations preserve=yes
  //## end CreateContourPlotGroups%4B4CDB6502B9.declarations

//## begin module%4B4CDAA7003F.epilog preserve=yes
//## end module%4B4CDAA7003F.epilog


#endif
